<?php

namespace App\Controller;

use App\Entity\Item;
use App\Entity\Ticket;
use App\Form\BuyTicketsType;
use App\Form\ItemType;
use App\Repository\ItemRepository;
use DateTime;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\Config\Definition\Exception\Exception;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/item")
 */
class ItemController extends Controller
{
    /**
     * @Route("/", name="item_index", methods="GET")
     */
    public function index(ItemRepository $itemRepository): Response
    {
        return $this->render('item/catalog.html.twig', ['items' => $itemRepository->findAll()]);
    }

    /**
     * @Route("/new", name="item_new", methods="GET|POST|PATCH")
     */
    public function new(Request $request): Response
    {
        $item = new Item();
        $form = $this->createForm(ItemType::class, $item);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $file = $item->getImage();
            $fileName = $this->generateUniqueFileName() . '.' . $file->guessExtension();

            // moves the file to the directory where brochures are stored
            $file->move(
                $this->getParameter('brochures_directory'),
                $fileName
            );

            $item->setImage($fileName);
            $item->setDate(new \DateTime());
            $item->setSeller($this->getUser());

            $em = $this->getDoctrine()->getManager();
            $em->persist($item);
            $em->flush();

            return $this->redirectToRoute('item_index');
        }

        return $this->render('item/new.html.twig', [
            'item' => $item,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="item_show", methods="GET")
     */
    public function show(Item $item, Request $request): Response
    {
        if ($this->getUser() != null) {

            $form = $this->createForm(BuyTicketsType::class, $item);
            $form->handleRequest($request);

            return $this->render('item/show.html.twig', ['item' => $item, 'user' => $this->getUser()->getMail(),'form2'=>$form->createView()]);
        } else {
            return $this->render('item/show.html.twig', ['item' => $item, 'app.user.username' => '0']);
        }
    }

    /**
     * @Route("/{id}/edit", name="item_edit", methods="GET|POST")
     */
    public function edit(Request $request, Item $item): Response
    {
        $form = $this->createForm(ItemType::class, $item);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {


            $file = $item->getImage();

            echo "<script>alert('" . $file . "')</script>";


            $fileName = $this->generateUniqueFileName() . '.' . $file->guessExtension();

            // moves the file to the directory where brochures are stored
            $file->move(
                $this->getParameter('brochures_directory'),
                $fileName
            );

            $item->setImage($fileName);


            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('item_edit', ['id' => $item->getId()]);
        }

        return $this->render('item/edit.html.twig', [
            'item' => $item,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="item_delete", methods="DELETE")
     */
    public function delete(Request $request, Item $item): Response
    {
        if ($this->isCsrfTokenValid('delete' . $item->getId(), $request->request->get('_token'))) {
            $em = $this->getDoctrine()->getManager();
            $em->remove($item);
            $em->flush();
        }

        return $this->redirectToRoute('item_index');
    }


    /**
     * @return string
     */
    private function generateUniqueFileName()
    {
        // md5() reduces the similarity of the file names generated by
        // uniqid(), which is based on timestamps
        return md5(uniqid());
    }

    /**
     * @Route("/buyTickets/{id}", name="buyTickets", methods="POST|GET")
     * @throws \Exception
     */
    public function buyItem(Request $request, Item $item)
    {

        //$form = $this->createForm(BuyTicketsType::class,$item);
        //$form->handleRequest($request);

        $entityManager = $this->getDoctrine()->getManager();

        //if ($form->isSubmitted() && $form->isValid()) {

            if ($item->getSoldTickets() < $item->getNbreTickets()) {

                // On incrémente les tickets
                $item->setSoldTickets($item->getSoldTickets()+1);

                 // On crée un ticket
                $ticket = new Ticket();
                $ticket->setItem($item);
                $ticket->setBuyer($this->getUser());
                $ticket->setDate(new \DateTime());
                $ticket->setTicketNumber(1);

                $entityManager->persist($ticket);
                $entityManager->flush();


                // On persiste
                $this->getDoctrine()->getManager()->flush();

           }
            return $this->redirectToRoute('item_show', ['id' => $item->getId()]);
        //}
       // return $this->render('item/show.html.twig', ['item' => $item, 'user' => $this->getUser()->getMail(),'form2'=>$form->createView()]);

    }
}
